package impresion;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;

public class SpoolerTestCase {

	private Spooler spooler;
	private Spooler emptySpooler;
	private Document firstDocument;
	private Document secondDocument;
	private Document thirdDocument;
	
	@Before
	public void setup(){
		this.firstDocument = new Document();
		this.secondDocument = new Document();
		this.thirdDocument = new Document();
		this.spooler = new Spooler();
		this.emptySpooler = new Spooler();
		spooler.spool(firstDocument);
		spooler.spool(secondDocument);
	}
	
	@Test
	public void testSpool() {
		Document d = this.spooler.nextDocument();
		assertNull(d);
		
		spooler.spool(thirdDocument);
		d = this.spooler.nextDocument();
		assertTrue(d.equals(thirdDocument));
		
		d = this.spooler.nextDocument();
		assertNull(d);
	}
	
	@Test
	public void testNextDocument() {
		Document d = this.spooler.nextDocument();
		assertTrue(d.equals(firstDocument));
		
		d = this.spooler.nextDocument();
		assertTrue(d.equals(secondDocument));
		
		d = this.spooler.nextDocument();
		assertNull(d);
	}

}
